The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::FileWvOut Class Reference

STK audio file output class. More...

`#include <FileWvOut.h>`

Inheritance diagram for stk::FileWvOut:

List of all members.

## Public Member Functions
| FileWvOut (unsigned int bufferFrames=1024)
| Default constructor with optional output buffer size argument.
| FileWvOut (std::string fileName, unsigned int nChannels=1, FileWrite::FILE_TYPE type=FileWrite::FILE_WAV, Stk::StkFormat format=STK_SINT16, unsigned int bufferFrames=1024)
| Overloaded constructor used to specify a file name, type, and data format with this object.
virtual | ~FileWvOut ()
| Class destructor.
void | openFile (std::string fileName, unsigned int nChannels, FileWrite::FILE_TYPE type, Stk::StkFormat format)
| Open a new file with the specified parameters.
void | closeFile (void)
| Close a file if one is open.
void | tick (const StkFloat sample)
| Output a single sample to all channels in a sample frame.
void | tick (const StkFrames &frames)
| Output the StkFrames data.

## Detailed Description

STK audio file output class.

This class inherits from WvOut. It provides a "tick-level" interface to the FileWrite class.

FileWvOut writes samples to an audio file and supports multi-channel data. It is important to distinguish the tick() method that outputs a single sample to all channels in a sample frame from the overloaded one that takes a reference to an StkFrames object for multi-channel and/or multi-frame data.

See the FileWrite class for a description of the supported audio file formats.

Currently, FileWvOut is non-interpolating and the output rate is always Stk::sampleRate().

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::FileWvOut::FileWvOut | ( | unsigned int | bufferFrames = `1024` | ) |

Default constructor with optional output buffer size argument.

The output buffer size defines the number of frames that are accumulated between writes to disk.

stk::FileWvOut::FileWvOut | ( | std::string | fileName,
|  | unsigned int | nChannels = `1`,
|  | FileWrite::FILE_TYPE | type = `FileWrite::FILE_WAV`,
|  | Stk::StkFormat | format = `STK_SINT16`,
|  | unsigned int | bufferFrames = `1024` |
| ) |  |  |

Overloaded constructor used to specify a file name, type, and data format with this object.

An StkError is thrown for invalid argument values or if an error occurs when initializing the output file.

## Member Function Documentation

void stk::FileWvOut::openFile | ( | std::string | fileName,
|  | unsigned int | nChannels,
|  | FileWrite::FILE_TYPE | type,
|  | Stk::StkFormat | format |
| ) |  |  |

Open a new file with the specified parameters.

If a file was previously open, it will be closed. An StkError will be thrown if any of the specified arguments are invalid or a file error occurs during opening.

void stk::FileWvOut::closeFile | ( | void |  | ) |

Close a file if one is open.

Any data remaining in the internal buffer will be written to the file before closing.

void stk::FileWvOut::tick | ( | const StkFloat | sample | ) | `[virtual]`

Output a single sample to all channels in a sample frame.

An StkError is thrown if an output error occurs.

Implements stk::WvOut.

void stk::FileWvOut::tick | ( | const StkFrames & | frames | ) | `[virtual]`

Output the StkFrames data.

An StkError will be thrown if an output error occurs. An StkError will also be thrown if _STK_DEBUG_ is defined during compilation and there is an incompatability between the number of channels in the FileWvOut object and that in the StkFrames object.

Implements stk::WvOut.

The documentation for this class was generated from the following file:

- FileWvOut.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.